<?php
################################################################################
# @Name : ./core/export_assets.php
# @Desc : dump csv files of all assets
# @call : /stat.php
# @parameters : 
# @Author : Flox
# @Create : 11/02/2016
# @Update : 27/01/2017
# @Version : 3.1.16
################################################################################

//locales
$lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
if ($lang=='fr') {$_GET['lang'] = 'fr_FR';}
else {$_GET['lang'] = 'en_US';}

define('PROJECT_DIR', realpath('../'));
define('LOCALE_DIR', PROJECT_DIR .'/locale');
define('DEFAULT_LOCALE', '($_GET[lang]');
require_once('../components/php-gettext/gettext.inc');
$encoding = 'UTF-8';
$locale = (isset($_GET['lang']))? $_GET['lang'] : DEFAULT_LOCALE;
T_setlocale(LC_MESSAGES, $locale);
T_bindtextdomain($_GET['lang'], LOCALE_DIR);
T_bind_textdomain_codeset($_GET['lang'], $encoding);
T_textdomain($_GET['lang']);

//initialize variables 
if(!isset($_GET['token'])) $_GET['token'] = 'XXX'; 

//database connection
require "../connect.php"; 

//get last token
$query = $db->query("SELECT token FROM `ttoken` ORDER BY id DESC LIMIT 1");
$token=$query->fetch(); 
$query->closeCursor();

//truncate table
$query = $db->query("TRUNCATE TABLE `ttoken`");

//secure connect from athenticated user
if ($token['token']==$_GET['token'])
{
	//get current date
	$daydate=date('Y-m-d');

	//output headers so that the file is downloaded rather than displayed
	header("Content-Type: text/csv; charset=utf-8");
	header("Content-Disposition: attachment; filename=\"$daydate-GestSup-export-asset.csv\"");

	//load parameters table
	$qparameters = $db->query("SELECT * FROM `tparameters`"); 
	$rparameters= $qparameters->fetch();
	$qparameters->closeCursor();

	//create a file pointer connected to the output stream
	$output = fopen('php://output', 'w');

	//output the column headings
	fprintf($output, chr(0xEF).chr(0xBB).chr(0xBF));
	fputcsv($output, array(T_('Numéro de l\'équipement'), T_('Numéro de série constructeur'), T_('Numéro de commande'), T_('IP LAN'), T_('IP Wifi'), T_('Nom de l\'équipement'), T_('Description'), T_('Type'), T_('Fabriquant'), T_('Modèle'),T_('Utilisateur'), T_('État'), T_('Adresse MAC LAN'),T_('Adresse MAC WIFI'),T_('Service'), T_('Date installation'), T_('Date fin de garantie'), T_('Date stock'), T_('Date de Standbye'), T_('Date de recyclage'), T_('Date du dernier ping'), T_('Numéro de prise'), T_('Technicien'), T_('Service de maintenance')),";");

	//fetch the data
	$query = $db->query('SELECT sn_internal,sn_manufacturer,sn_indent,ip,ip2,netbios,description,type,manufacturer,model,user,state,mac_lan,mac_wlan,department,date_install,date_end_warranty,date_stock,date_standbye,date_recycle,date_last_ping,socket,technician,maintenance FROM tassets WHERE disable=0');

	//loop over the rows, outputting them
	while ($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		//get data
		$query2=$db->query("SELECT name FROM tassets_type WHERE id LIKE '$row[type]' "); 
		$row2=$query2->fetch();
		$query2->closeCursor(); 
		$row['type']="$row2[0]";
		
		$query2=$db->query("SELECT name FROM tassets_manufacturer WHERE id LIKE '$row[manufacturer]' "); 
		$row2=$query2->fetch();
		$query2->closeCursor(); 
		$row['manufacturer']="$row2[0]";
		
		$query2=$db->query("SELECT name FROM tassets_model WHERE id LIKE '$row[model]' "); 
		$row2=$query2->fetch();
		$query2->closeCursor(); 
		$row['model']="$row2[0]";
		
		$query2=$db->query("SELECT firstname, lastname FROM tusers WHERE id LIKE '$row[user]' "); 
		$row2=$query2->fetch();
		$query2->closeCursor(); 
		$row['user']="$row2[0] $row2[1]";	
		
		$query2=$db->query("SELECT name FROM tassets_state WHERE id LIKE '$row[state]' "); 
		$row2=$query2->fetch();
		$query2->closeCursor(); 
		$row['state']="$row2[0]";	
		
		$query2=$db->query("SELECT name FROM tservices WHERE id LIKE '$row[department]' "); 
		$row2=$query2->fetch();
		$query2->closeCursor(); 
		$row['department']="$row2[0]";
		
		$query2=$db->query("SELECT firstname, lastname FROM tusers WHERE id LIKE '$row[technician]' "); 
		$row2=$query2->fetch();
		$query2->closeCursor(); 
		$row['technician']="$row2[0] $row2[1]";	
		
		$query2=$db->query("SELECT name FROM tservices WHERE id LIKE '$row[maintenance]' "); 
		$row2=$query2->fetch();
		$query2->closeCursor(); 
		$row['maintenance']="$row2[0]";

		fputcsv($output, $row,';');
	}
} else {
	echo '<br /><br /><center><font size="5" color="red"><b>'.T_('Accès à cette page interdite, contactez votre administrateur').'.</b></font></center>';	
}
$db = null;
?>